package org.firstinspires.ftc.teamcode.subsystem;

import static org.firstinspires.ftc.teamcode.PedroConstants.LEFT_ENCODER;
import static org.firstinspires.ftc.teamcode.configs.RobotConstants.liftPower;

import com.acmerobotics.roadrunner.Action;
import com.qualcomm.robotcore.hardware.DcMotor;
import com.qualcomm.robotcore.hardware.DcMotorSimple;
import com.qualcomm.robotcore.hardware.HardwareMap;

public class SkyHookSubsystem {

    public DcMotor hook;

    public enum SkyHookState {
        UP, DOWN, STOP
    }

    private SkyHookState skyHookState;

    public SkyHookSubsystem(HardwareMap hardwareMap) {
        hook = hardwareMap.get(DcMotor.class, LEFT_ENCODER);
    }



   public void raiseHook(double power){
        this.hook.setPower(power);
        this.hook.setDirection(DcMotorSimple.Direction.FORWARD);
        this.setState(SkyHookState.UP);
   }
    public void lowerHook(double power){
        this.hook.setPower(power);
        this.hook.setDirection(DcMotorSimple.Direction.REVERSE);
        this.setState(SkyHookState.DOWN);
    }
    public void init() {
        hook.setPower(0);
        hook.setMode(DcMotor.RunMode.RUN_WITHOUT_ENCODER);
    }

    private void setState(SkyHookState liftState) {
        this.skyHookState = liftState;
    }

    public SkyHookState getState() {
        return this.skyHookState;
    }



}
